--- old/usr/src/uts/common/fs/tmpfs/tmp_vfsops.c	2016-07-18 05:17:50.795724327 +0100
+++ new/usr/src/uts/common/fs/tmpfs/tmp_vfsops.c	2016-07-18 05:17:50.814831789 +0100
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011, Joyent, Inc. All rights reserved.
+ * Copyright 2016 RackTop Systems.
  */
 
 #include <sys/types.h>
@@ -589,7 +590,7 @@
 	 * If tm_anonmax for this mount is less than the available swap space
 	 * (minus the amount tmpfs can't use), use that instead
 	 */
-	if (blocks > tmpfs_minfree)
+	if (blocks > tmpfs_minfree && tm->tm_anonmax > tm->tm_anonmem)
 		sbp->f_bfree = MIN(blocks - tmpfs_minfree,
 		    tm->tm_anonmax - tm->tm_anonmem);
 	else
@@ -630,13 +631,9 @@
 	 * available to tmpfs.  This is fairly inaccurate since it doesn't
 	 * take into account the names stored in the directory entries.
 	 */
-	if (tmpfs_maxkmem > tmp_kmemspace)
-		sbp->f_ffree = (tmpfs_maxkmem - tmp_kmemspace) /
-		    (sizeof (struct tmpnode) + sizeof (struct tdirent));
-	else
-		sbp->f_ffree = 0;
-
-	sbp->f_files = tmpfs_maxkmem /
+	sbp->f_ffree = sbp->f_bfree == 0 ? 0 : sbp->f_bfree /
+	    (sizeof (struct tmpnode) + sizeof (struct tdirent));
+	sbp->f_files = sbp->f_blocks == 0 ? 0 : sbp->f_blocks /
 	    (sizeof (struct tmpnode) + sizeof (struct tdirent));
 	sbp->f_favail = (fsfilcnt64_t)(sbp->f_ffree);
 	(void) cmpldev(&d32, vfsp->vfs_dev);
